Description: Currently, only @FR@ and @ES@ languages are supported by the automultiplechoice LaTeX package 

@lang@ option.
Add @DE@ and @IT@.

History
03/01/2012 12:08 am - ChiliProject Admin
- Category set to LaTeX

03/14/2012 03:33 pm - Hiroto Kagotani
Additionally, I would like JA (Japanese) support.
The following is the JA localized text.

<pre>
\def\AMC@loc@JA{
  \def\AMC@loc@draft{ドラフト}
  \def\AMC@loc@message{試験の実施には、auto-mutiple-choiceでコンパイルされた文書を印刷してください。}
  \def\AMC@loc@qf##1{\textbf{問##1:}}
  \def\AMC@loc@q##1##2{\textbf{問##1} ##2}
  \def\AMC@loc@corrected{模範解答}
  \def\AMC@loc@catalog{問題カタログ}
  \def\AMC@loc@none{該当なし。}
}
</pre>

03/14/2012 06:45 pm - Alexis Bienvenüe
- Subject changed from Add lang=DE|IT package options to Add lang=DE|IT|JA package options

Thank you very much. Is it possible to use pdflatex to make a Japanese document, or is it necessary to use xelatex? If xelatex is required, I will add a 
little code to print an error in case latex is used with lang=JA option.

03/15/2012 05:49 am - Hiroto Kagotani
Thanks.

In fact, latex environment for Japanese text is a little bit complicated.

Pdflatex does not handle Japanese text.
Xelatex does with some font settings in the preamble of the source and additional font installation, but it does not handle completely Japanese spacing 
and line breaking.
Usually, latex users in Japan use "platex" + dvipdfmx, which are distributed with TeXLive2011.  Older version of platex is also used by some people, 
but it does not have \pdfsavepos feature and does not handle UTF-8 encoding.

Further, ghostscript does not handle PDF produced by dvipdfmx with standard font settings; Japanese fonts must be embedded in PDF.

For these reasons, in order to fully support Japanese text, some additional documentation for Japanese users will be required.
I am providing materials step by step from easier ones.  The easiest one is the lang=JA option for automultiplechoice package.  The second may be 
GUI translation.  And so on...

03/15/2012 09:20 am - Alexis Bienvenüe
Thank you for your explanation, and for your work. I include your patch as is.

Perhaps it could be also interesting (and not too difficult) to amend the AMC-TXT "filter" (available in development versions of AMC, see included 
documentation) to allow Japanese exams to be handled without LaTeX knowledge? If you think this is interesting and if you have a little time, look at a 
DOC-filtered.tex made by the AMC-TXT filter for an english exam and see if some little changes could make it usable for Japanese texts.

03/19/2012 10:59 am - Hiroto Kagotani
I tested AMC-TXT filter feature and looked in DOC-filtered.tex.
Then I found some slight modification made the feature available for Japanese exam.

* use "platex+dvipdfmx" instead of xelatex.
* xltxtra package must not be used.
* font option (\setmainfont) must not be used. ("Linux Libertine O" is implicitly specified by default)

Here are some related things:
* Can't I enter my favorite LaTeX engine in preferences window?  I could do it with AMC-1.0.3.
* Changing source file format does not change source file name (extention). Is there any way to change source file name?

Also, I misspelled the program name in the Japanese text at \AMC@loc@message above.
Please correct "auto-mutiple-choice" to "auto-multiple-choice" in the latex package file.

03/19/2012 11:20 am - Alexis Bienvenüe
Thank you for your help.

> Can't I enter my favorite LaTeX engine in preferences window? I could do it with AMC-1.0.3.

When preparing working documents, the AMC-TXT filter sets (overwrite, if this setting was already set by the user) the engine to @xelatex@ since the 
produced LaTeX file is made to work with @xelatex@. I propose the following:
* when using "@Lang: JA@" option, set the (default) engine to "@platex+dvipdfmx@" instead
* add an option _LaTeXEngine:_ to overwrite if needed
* grey out the corresponding entry in the edit/preferences window

> * xltxtra package must not be used.
> * font option (\setmainfont) must not be used. ("Linux Libertine O" is implicitly specified by default)

I will remove these for @JA@ exams (setting default @Font:@ to empty for the second).

> Changing source file format does not change source file name (extention). Is there any way to change source file name?

Since revision r927, the filename is changed only for new projects created with empty source file and in the case the file has not yet been edited. Maybe 
I should add a button to change the source file name...

> Please correct "auto-mutiple-choice" to "auto-multiple-choice" in the latex package file.

Yes, thanks.

03/19/2012 11:22 am - Alexis Bienvenüe
Could you post a Japanese AMC-TXT sample file so that I can make some tests?
03/19/2012 11:55 am - Hiroto Kagotani

Here is the sample.
<pre>
# AMC-TXT file
Title: 試験タイトル（Paper title）
Lang: JA
Font:

* カメルーンの首都はどれですか？（Which is the capital city of Cameroon?）
+ ヤウンデ（Yaounde）
- ドゥアラ（Douala）
- クリビ（Kribi）
</pre>

03/19/2012 02:24 pm - Alexis Bienvenüe
- File DOC-filtered.tex added

My platex fails with
<pre>
! Undefined control sequence.
l.27 \unless
                      \collect@body
</pre>
and
<pre>
! Undefined control sequence.
\AMC@traceposy ...pty #1\@empty \else \pdfsavepos
                                                  \protected@write \AMC@XYFI...
</pre>
Maybe I have an outdated version of platex? Or am I missing something?
<pre>
This is pTeXk, Version 3.141592-p3.1.11 (euc) (Web2C 7.5.4)
 %&-line parsing enabled.
pLaTeX2e <2006/11/10>+0 (based on LaTeX2e <2009/09/24> patch level 0)
</pre>

03/19/2012 03:16 pm - Hiroto Kagotani
- File DOC-filtered.pdf added

> Maybe I have an outdated version of platex?
I'm afraid yes.
My platex prints the following message and successfully processes your DOC-filtered.tex and dvipdfmx produced the attached PDF.
> This is e-pTeX, Version 3.1415926-p3.2-110825-2.3 (utf8.euc) (TeX Live 2011) (format=platex 2012.3.2)  19 MAR 2012 22:33
> (snip)
> pLaTeX2e <2006/11/10> (based on LaTeX2e <2011/06/27> patch level 0)

Someone wrote on his blog that platex in Debian's stable packages was outdated but recently they updated experimental packages for TeXLive (with 
new platex) at:
http://packages.debian.org/en/experimental/tex/
(http://wiki.debian.org/DebianExperimental)
Please have a try on texlive-lang-cjk and other related packages.

03/19/2012 03:25 pm - Alexis Bienvenüe
Thanks very much for the links. I installed a "vanilla texlive 2011":http://www.tug.org/texlive/debian.html in a debian virtual machine and now it works 
well... I will have to wait a little for the new package in experimental to enter unstable or testing.

So we can try the filter with Japanese exams starting from revision r934.

03/20/2012 08:41 am - Hiroto Kagotani
Revision r934 works very well for my AMC-TXT format exam
(except for graying out the latex engine entry).
Thank you!

03/20/2012 11:08 am - Alexis Bienvenüe
> (except for graying out the latex engine entry).

Yes I forgot this. It should be ok since revision r936.

04/02/2012 02:59 pm - Alexis Bienvenüe
- % Done changed from 0 to 100

- Status changed from New to Resolved

Applied in changeset r988.

04/02/2012 03:00 pm - Alexis Bienvenüe
- Status changed from Resolved to Closed

05/06/2012 04:07 pm - Alexis Bienvenüe
> Someone wrote on his blog that platex in Debian's stable packages was outdated but recently they updated experimental packages for TeXLive (with 
new platex)

New TeXlive packages are now available in debian testing, so that AMC is working with Japanese exams. That's great!

Files
DOC-filtered.tex 817 Bytes 03/19/2012 Alexis Bienvenüe
DOC-filtered.pdf 32.6 kB 03/19/2012 Hiroto Kagotani
